#!/usr/bin/perl -sw -I../lib
use strict;
use IO::Pty::Script qw(chat DEFAULT_DEADLINE);
use threads;
use threads::shared;
use File::Basename;
use Term::ReadKey;
use Data::Dumper;
use List::Util qw(sum);
use constant DEFAULT_RDIR => '/tmp';  # Default remote directory

our($p, $d);                  # Inicializadas via -s switch
my $N = 10000;          # Num intervals
my %script;
my $local_exe = './pi';
my $prompt = '[$>#] ';
my @result : shared;

$p = &read_pass unless (defined $p);
$d = DEFAULT_DEADLINE unless defined($d);

sub read_pass {
  print "Password: ";
  ReadMode('noecho');
  $p = ReadLine(0);
  ReadMode('normal');
  print "\n";
  chomp($p);
  return $p;
}

sub write_result {
  my $self = shift;
  my $id = shift; # que si hay retornos de carro?
  $result[$id] = $self->answer;
  "exit\n";
}

sub par_batch {
  my $command = shift;
  my @machines = @{shift()};
  my $scripts = shift;

  my $lastworker = $#machines;
  my $i;
  my @t;
  for $i (0..$lastworker) {
    $t[$i] = threads->new(
      \&chat, 
      @{$scripts->[$i]},
    )
  }
  my @result;
  for $i (0..$lastworker) {
    $result[$i] = $t[$i]->join();
  }
}

my $beoscript = <<'BEOWULF1';
.*password:\s'   => "$p\n",
$prompt       => "/home/casiano/pi ID N NUM_WORKERS\n",
qr/\d+\.\d*/        => [ \&write_result, ID ] 
BEOWULF1

my $beotmp = Text::Template->new(TYPE => 'STRING', SOURCE => $beoscript);

my @machines = ( 
  [ # Primera maquina
    {
    command => 'ssh -l casiano beowulf',
    deadline => 5,
    defaultaction => sub { print $_[0] },
    script => $beotmp
    }
  ],
);

my $num_workers = @machines;

# Un script es un esqueleto que se instancia con la mquina 
# y quiz con los parmetros?
# my @scripts = (
#    {
#    command => copy_command
#    script => [...]
#    deadline => ...
#    },
#    ...
# );

my @scripts = map {
      [
      command => 'ssh -l casiano beowulf',
      deadline => 5,
      defaultaction => sub { print $_[0] },
      script => [
          '.*password:\s'   => "$p\n",
          $prompt       => "/home/casiano/pi $_ $N $num_workers\n",
          qr/\d+\.\d*/        => [ \&write_result, $_ ] 
         ]
       ]
   } 0..$#machines;

&par_batch($local_exe, \@machines, \@scripts);
local $" = "\n";
print "@{result}\nResult = ".sum(@result)."\n";

