#!/usr/bin/perl -sw -I../lib
use strict;
use IO::Pty::Script qw(chat DEFAULT_DEADLINE);
use threads;
use threads::shared;
use File::Basename;
use Term::ReadKey;
use List::Util qw(sum);
use constant N => 10000;          # Num intervals
use constant DEFAULT_RDIR => '/tmp';  # Default remote directory

our($p, $d);                  # Inicializadas via -s switch
my %script;
my $local_exe = './pi';
my $prompt = '[$>#] ';
my @result : shared;

$p = &read_pass unless (defined $p);
$d = DEFAULT_DEADLINE unless defined($d);

sub read_pass {
  print "Password: ";
  ReadMode('noecho');
  $p = ReadLine(0);
  ReadMode('normal');
  print "\n";
  chomp($p);
  return $p;
}

sub write_result {
  my $self = shift;
  my $id = shift; # que si hay retornos de carro?
  $result[$id] = $self->answer;
  "exit\n";
}

sub do_job {
  my $m = shift;
  my $id = shift;
  my $local_exe = shift;
  my @exeargs = @_;

  my $cmd = "$$m{'conn_cmd'} $$m{'host'}";
  my $exe;

  if (exists $$m{'copy_cmd'}) {
    my $r_dir = $$m{'r_dir'} || DEFAULT_RDIR;
    my $r_user = $$m{'r_user'};
    my $copy_cmd = "$$m{'copy_cmd'} $local_exe $r_user@" . "$$m{'host'}:$r_dir";

    die "No existe el archivo $local_exe" unless -r $local_exe;

    $script{$copy_cmd} = [
      '.*password:\s'           => "$p\n",
    ];

    &chat(command => $copy_cmd, deadline => $d, script => $script{$copy_cmd});
    
    $exe = $r_dir . basename $local_exe;
  } else {
    $exe = $local_exe;
  }

  $script{$cmd} = [
    '.*password:\s'   => "$p\n",
    $prompt       => "$exe @exeargs\n",
    qr/\d+\.\d*/        => [ \&write_result, $id ] # depende de la aplicacion
  ];

  &chat( command => $cmd, deadline => $d, script => $script{$cmd},
    defaultaction => sub { print $_[0] } );
}

sub par_batch {
  my $command = shift;
  my @machines = @{shift()};
  my $parameters = shift;

  my $lastworker = $#machines;
  my $i;
  my @t;
  for $i (0..$lastworker) {
    $t[$i] = threads->new(\&do_job, $machines[$i], $i, $command, @{$parameters->[$i]});
  }
  my @result;
  for $i (0..$lastworker) {
    $result[$i] = $t[$i]->join();
  }
}

my @machines = ( 
  {
    host    => 'beowulf',
    conn_cmd  => 'ssh -l casiano',
    copy_cmd => 'scp',
    r_dir   => '/home/casiano/',
    r_user  => 'casiano'
  },
  {
    host    => 'beowulf',
    conn_cmd  => 'ssh -l casiano',
    copy_cmd => 'scp',
    r_dir   => '/home/casiano/',
    r_user  => 'casiano'
  },
);

my $num_workers = @machines;
my @parameters = map { [ $_, N, $num_workers] } 0..$#machines;
&par_batch($local_exe, \@machines, \@parameters);
local $" = "\n";
print "@{result}\nResult = ".sum(@result)."\n";

